Public Class FrmInterest
    Dim InitialPrinciple As Double
    Dim CurrentPrinciple1 As Double
    Dim Interest As Double
    Dim YearCounter1 As Integer = 0


    '************************************************************
    'This method uses "User-driven" repetition -- the user has to 
    'click the button each time to get another year's interest 
    'calculated and added to the principle
    Private Sub btnInterest1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnInterest1.Click

        'if this calculation is starting (Year=0) then retrieve
        'information from textboxes
        If YearCounter1 = 0 Then

            'get principle from textbox

            'the andalso is known as a "short-circuited" boolean 
            'operator In this case we only look at the second condition 
            'if the first is found to be true
            If IsNumeric(txtPrinciple.Text) AndAlso txtPrinciple.Text > 0 Then
                InitialPrinciple = txtPrinciple.Text
                CurrentPrinciple1 = InitialPrinciple
            Else
                MsgBox("Please enter a (positive) number for the principle.")
                txtPrinciple.Clear()
                txtPrinciple.Focus()
                Exit Sub
            End If

            'get interest from textbox
            If IsNumeric(txtInterest.Text) AndAlso txtInterest.Text > 0 Then
                Interest = txtInterest.Text
            Else
                MsgBox("Please enter a (positive) number for the interest.")
                txtInterest.Clear()
                txtInterest.Focus()
                Exit Sub
            End If
        End If

        'increment the year 
        YearCounter1 += 1

        'calculate the new principle
        CurrentPrinciple1 *= (1 + Interest / 100)

        'display result 
        txtResult1.Text += "Year " & YearCounter1 & ": " & Format(CurrentPrinciple1, "Currency") & vbCrLf
    End Sub

    '************************************************************
    'This method uses "code-driven" repetition -- the user has to 
    'click the button once to get several year's interest calculated 
    'and added to the principle
    Private Sub btnInterest2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnInterest2.Click
        Dim NumberOfYears As Integer
        Dim YearCounter2 As Integer
        Dim CurrentPrinciple2 As Double

        'get principle from textbox
        If IsNumeric(txtPrinciple.Text) AndAlso txtPrinciple.Text > 0 Then
            InitialPrinciple = txtPrinciple.Text
            CurrentPrinciple2 = InitialPrinciple
        Else
            MsgBox("Please enter a (positive) number for the principle.")
            txtPrinciple.Clear()
            txtPrinciple.Focus()
            Exit Sub
        End If

        'get interest from textbox
        If IsNumeric(txtInterest.Text) AndAlso txtInterest.Text > 0 Then
            Interest = txtInterest.Text
        Else
            MsgBox("Please enter a (positive) number for the interest.")
            txtInterest.Clear()
            txtInterest.Focus()
            Exit Sub
        End If

        'get number of years from textbox 
        If IsNumeric(txtYear.Text) AndAlso txtYear.Text > 0 Then
            NumberOfYears = CInt(txtYear.Text)
        Else
            MsgBox("Please enter a (positive) number for the years.")
            txtYear.Clear()
            txtYear.Focus()
            Exit Sub
        End If

        'NEW!  NEW!  NEW!  NEW! 
        'A For Loop provides repition in code 
        'They are typically used when you know how many iterations there will be 

        'The first line of the for loop indicates a variable to use 
        'for counting, where that counting should start and where it 
        'should end
        For YearCounter2 = 1 To NumberOfYears
            CurrentPrinciple2 *= (1 + Interest / 100)
            txtResult2.Text += "Year " & YearCounter2 & ": " & Format(CurrentPrinciple2, "Currency") & vbCrLf
        Next

    End Sub

    '************************************************************
    'clear out results if user changes principle input
    Private Sub txtPrinciple_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtPrinciple.TextChanged
        txtResult1.Clear()
        txtResult2.Clear()
        YearCounter1 = 0
    End Sub

    '************************************************************
    'clear out results if user changes interest input
    Private Sub txtInterest_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtInterest.TextChanged
        txtResult1.Clear()
        txtResult2.Clear()
        YearCounter1 = 0
    End Sub

    '************************************************************
    'clear out 2nd result if user changes number of years input
    Private Sub txtYear_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtYear.TextChanged
        txtResult2.Clear()
    End Sub

    '************************************************************
    'Reinitialize all input and output
    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        txtResult1.Clear()
        txtResult2.Clear()
        YearCounter1 = 0
        txtPrinciple.Clear()
        txtInterest.Clear()
        txtYear.Clear()
    End Sub
End Class
